package {
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import com.fileitup.fisixengine.core.FisixEngine;
	import com.fileitup.fisixengine.collisions.ReactionModes;
	import flash.events.Event;
	import com.fileitup.fisixengine.core.Vector;
	import com.fileitup.fisixengine.core.FisixObject;
	import flash.events.MouseEvent;
	import com.fileitup.fisixengine.particles.CircleParticle;

	[SWF(width="450", height="400", frameRate="30", backgroundColor="0xEEEEEE")]
	public class Exam_Explode extends Sprite
	{
		[Embed(source="Bomb.swf", symbol="Bomb")]
		private var Bomb:Class;//폭탄
		
		private var myEngine:FisixEngine;
		private var circleNum:int = 1;
		
		public function Exam_Explode()
		{
			//엔진 기본 설정
			myEngine = new FisixEngine();
			myEngine.setReactionMode(ReactionModes.PHYSICAL);
			myEngine.setGravity(0,1);
			myEngine.setRender(true);
			myEngine.setRenderGraphics(graphics);
			this.addEventListener(Event.ENTER_FRAME, on_EnterFrame);
			//아래부터 내용 작성
			this.drawWalls(myEngine);//벽 만들기
			this.stage.addEventListener(MouseEvent.MOUSE_DOWN, on_MouseDown);//폭탄 생성
		}
		private function on_EnterFrame(e:Event):void {
			myEngine.mainLoop(1);
			var circle:CircleParticle;
			if(this.circleNum < 30){
				for(var i:int = 0; i<3; i++){
					circle = new CircleParticle(int(Math.random()*400)+50,300,20);
					//16진수 랜덤 뽑기 시작
					var r:int = new int(int(Math.random()*256));
					var g:int = new int(int(Math.random()*256));
					var b:int = new int(int(Math.random()*256));
					var rStr:String = r.toString(16);
					var gStr:String = g.toString(16);
					var bStr:String = b.toString(16);
					if(rStr.length<2) rStr = "0"+rStr;
					if(gStr.length<2) gStr = "0"+gStr;
					if(bStr.length<2) bStr = "0"+bStr;
					var rgb:String = "0x"+ rStr+gStr+bStr;
					//16진수 랜덤 뽑기 끝
					circle.color = int(rgb);
					circle.mass = 10;
					circle.friction = 0.1;
					myEngine.addObject(circle);
				}
				this.circleNum++;
			}
		}
		/**
		 * 벽 만들기
		 */
		private function drawWalls(_engine:FisixEngine):void {
			var walls:FisixObject = _engine.newFisixObject();
			var W:Number = this.stage.stageWidth;
			var H:Number = this.stage.stageHeight;
			walls.newSurface(new Vector(0,0),new Vector(W,0),10);
			walls.newSurface(new Vector(W,0),new Vector(W,H),10);
			walls.newSurface(new Vector(W,H),new Vector(0,H),10);
			walls.newSurface(new Vector(0,H),new Vector(0,0),10);
			walls.makeStatic();
		}
		/**
		 * 폭탄 생성
		 */
		private function on_MouseDown(e:MouseEvent):void {
			var bomb:MovieClip = new Bomb();
			bomb.addEventListener(Event.ENTER_FRAME, on_BombEnterFrame);
			this.addChild(bomb);
			
			var cp:CircleParticle = myEngine.newCircleParticle(e.localX, e.localY, 6);
			cp.mass = 10;
			cp.color = 0xEEEEEE;
			myEngine.newParticleAttacher(bomb, cp);
		}
		private function on_BombEnterFrame(e:Event):void {
			var bomb:MovieClip = MovieClip(e.currentTarget);
			if(bomb.currentFrame >= bomb.totalFrames){
				bomb.removeEventListener(Event.ENTER_FRAME, on_BombEnterFrame);
				myEngine.explode(new Vector(bomb.x, bomb.y), 1000);
				bomb.parent.removeChild(bomb);
			}
		}
	}
}
